/******************************************
 * Envoi de commandes en Midi
 * pour les modules 8 Actionneurs et 64 LED
 * Interface-Z
 * Sending Midi data to
 * 64 DEL and 8 Actuators modules from Interface-Z
 ******************************************
 * Pilotage de lampes et de LED
 * Lights and DEL actuators
 */

import promidi.*;

MidiIO midiIO;
MidiOut midiOut;

int compteur = 0;
// Valeur de la commande a envoyer
// Value to send
int[] valeur = new int[64];
// Numero de l'actionneur cible
// Target actuator number
int numact = 0;

void setup(){
  size(320, 180);
  background(0);
  noStroke();

  PFont fontA = loadFont("CourierNew36.vlw");
  textFont(fontA, 20);

  // Gestion des ports Midi
  // Midi ports management

  // Ouvrir une instance de MidiIO
  // Get an instance of MidiIO
  midiIO = MidiIO.getInstance(this);
  // Afficher une liste des peripheriques Midi disponibles
  // Print a list with all available Midi devices
  midiIO.printDevices();
  // Ouvrir une sortie Midi sur le premier peripherique et pour le premier canal 
  // Open a midiout using the first device and the first channel
  midiOut = midiIO.getMidiOut(0,0);
}

void draw(){
  background(0);
  // Affichage du texte
  // Text
  fill(255);
  text("Carte 8 Lampes ou 64 LED", 10, 30);
  text("Actionneur "+numact, 10, 70);
  text("Valeur "+valeur[numact], 10, 100);

  // Envoi des commandes aux lumieres
  // Sending data to lights
  if ((compteur%6 == 0) && (compteur<380)){
    valeur[numact] = 127;
    envoiPulseMidi();
  }
  if ((compteur%6 == 5) && (compteur<382)){
    valeur[numact] = 0;
    envoiPulseMidi();
    // Choix de l'actionneur  piloter
    // Choosing the actuator to move
    numact = numact + 1;
  }
  if (compteur == 382){
    valeur[numact] = 0;
    envoiPulseMidi();
    numact = 0;
  }

  // Running status Midi
  compteur=compteur+1;
  if (compteur==400){ 
    midiOut.sendProgramChange(new ProgramChange(0));
    compteur=0;
    println("Status");
  }
}

void envoiPulseMidi(){  
  // Envoi des ordres Midi
  // Sending Midi commands
  midiOut.sendController(new Controller(numact, valeur[numact]));  

  if((numact==0) || (numact==63)){
    println(compteur%6+"Envoie la valeur "+valeur[numact] +"  l'actionneur "+numact);
  }
}


